(() => {

  chrome.runtime.onMessage.addListener((obj, sender, response) => {
    const { type, activeTab } = obj;

    console.log('msg received', obj);

    if( type === "CHECKTOPCATEGORY_CNT") {

      console.log('msg CHECKTOPCATEGORY_CNT received', obj);

      // find first category from breacrumbs: div.a-breadcrumb > ul > li:nth-child(0) > span > a
      const breadcrumbTopCategory = document.querySelector('div.a-breadcrumb > ul > li:nth-child(1) > span > a');

      if (breadcrumbTopCategory) {

        // send a message to background.js to do the check
        let message = {
          type: "CHECKTOPCATEGORY_BG",
          tab: activeTab,
          topCategoryURL: breadcrumbTopCategory.href
        };

        // use the response from background.js as the response for this message
        chrome.runtime.sendMessage(message)
            .then((bgResponse) => {
              response(bgResponse);
            })
            .catch((error) => {
              console.error(error); // Log any error that occurred
              response(false);
            });

        // must return true to indicate we want to send a response asynchronously
        return true;
      }
      else {

        // response(false);

        response(true);  // allow products without breadcrumbs
        return true;
      }

    }
    else if (obj.action === "clickShowMore") {
      const showMoreLink = document.querySelector('#feature-bullets #showMore');
      if (showMoreLink) {
        showMoreLink.click();
        sendResponse({ status: "success" });
      } else {
        sendResponse({ status: "fail", message: "Show more link not found" });
      }
    }
  });


})();


// todo check to ensure that the user is logged in
// todo if user not logged in, prompt them to log in first before doing any other checks